#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Samo grupa A; ostale su jako slicne */

typedef struct _element {
  char word[52];
  int num;
  struct _element *next;
} element;

int palindrom(const char s[]) {
  int i = 0, j = strlen(s) - 1;
  while (i < j) {
    if (s[i] != s[j]) return 0;
    ++i; --j;
  }
  return 1;
}

void output(element *first) {
  element *t = first;
  int n = 0, sum = 0;
  while (t) {
    if (!palindrom(t->word)) {
      ++n;
      sum += t->num;
    }
    t = t->next;
  }
  if (n)
    printf("%g\n", (double)sum/n);
  else
    printf("nedefinirano\n", (double)sum/n);
}

element *del(element *first, const char s[], int *n, int *sum) {
  element *t;
  *n = 0, *sum = 0;
  while (first && strcmp(first->word, s) == 0) {
    ++(*n);
    *sum += first->num;
    t = first;
    first = first->next;
    free(t);
  }
  if (!first) return NULL;
  t = first;
  while (t->next)
    if (strcmp(t->next->word, s) == 0) {
      element *del = t->next;
      t->next = del->next;
      ++(*n);
      *sum += del->num;
      free(del);
    } else
      t = t->next;
  return first;
}

element *input(const char name[]) {
  FILE *fp = fopen(name, "rt");
  element *first = NULL;
  char word[52];
  int num;
  if (!fp) {
    printf("Greska kod otvaranja datoteke \"%s\" za citanje.\n");
    return NULL;
  }
  while (fscanf(fp, " %s %d", word, &num) == 2) {
    element *new = (element*)malloc(sizeof(element));
    strcpy(new->word, word);
    new->num = num;
    new->next = first;
    first = new;
  }
  fclose(fp);
  return first;
}

void out_all(element *first) {
  printf("\nLista:\n");
  while (first) {
    printf("  %-52s %d\n", first->word, first->num);
    first = first->next;
  }
}

void free_all(element *first) {
  while (first) {
    element *del = first;
    first = first->next;
    free(del);
  }
}

int main(void) {
  element *first = input("zad1.txt");
  char word[52];
  int n, sum;

  out_all(first);

  printf("\nRezultat output(first):\n");
  output(first);

  printf("Unesite rijec od max 51 znaka: ");
  scanf("%s", word);
  first = del(first, word, &n, &sum);
  out_all(first);
  printf("n = %d\nsum = %d\n", n, sum);

  free_all(first);

  return 0;
}

