#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
  unsigned kn, lp;
} Cijena;

int usp_cijene(const Cijena *c1, const Cijena *c2) {
  if (c1 == c2)
    return 0;
  if (c1->kn < c2->kn)
    return -1;
  if (c2->kn < c1->kn)
    return 1;
  if (c1->lp < c2->lp)
    return -1;
  if (c2->lp < c1->lp)
    return 1;
  return 0;
}

typedef struct {
  char oib[12];
  char naziv[32];
  Cijena cijena;
} Ponuda;

int usp_ponude(const Ponuda *p1, const Ponuda *p2) {
  int c;
  if (p1 == p2)
    return 0;
  if (c = strcmp(p1->naziv, p2->naziv))
    return c < 0 ? -1 : 1;
  return usp_cijene(&(p1->cijena), &(p2->cijena));
}

int nadji(FILE *f, const char *naziv) {
  int left, right, half, c = 1;
  Ponuda p;
  (void)fseek(f, 0l, SEEK_END);
  left = 0;
  right = (int)(ftell(f) / sizeof(Ponuda)) - 1;
  while (left <= right) {
    half = left + (right - left) / 2;
    (void)fseek(f, half * sizeof(Ponuda), SEEK_SET);
    (void)fread(&p, sizeof(Ponuda), 1, f);
    c = strcmp(naziv, p.naziv);
    if (c < 0)
      right = half - 1;
    else if (c > 0)
      left = half + 1;
    else
      break;
  }
  if (c) {
    (void)fseek(f, 0l, SEEK_END);
    return EOF;
  }
  while (half > 0) {
    (void)fseek(f, --half * sizeof(Ponuda), SEEK_SET);
    (void)fread(&p, sizeof(Ponuda), 1, f);
    if (strcmp(naziv, p.naziv)) {
      ++half;
      break;
    }
  }
  (void)fseek(f, half * sizeof(Ponuda), SEEK_SET);
  return half;
}

int sortiraj(FILE *f) {
  int len, srt, cnt = 1, end, i;
  Ponuda wnd[3];
  (void)fseek(f, 0l, SEEK_END);
  len = (int)(ftell(f) / sizeof(Ponuda));
  do {
    srt = 1;
    end = len - cnt;
    rewind(f);
    for (i = 0; i < end; ++i) {
      (void)fread(wnd, sizeof(Ponuda), 2, f);
      if (usp_ponude(wnd + 0, wnd + 1) > 0) {
	wnd[2] = wnd[0];
	wnd[0] = wnd[1];
	wnd[1] = wnd[2];
	(void)fseek(f, -2l * sizeof(Ponuda), SEEK_CUR);
	(void)fwrite(wnd, sizeof(Ponuda), 2, f);
	srt = 0;
      }
      (void)fseek(f, -1l * sizeof(Ponuda), SEEK_CUR);
    }
    if (srt)
      rewind(f);
    else
      ++cnt;
  } while (!srt);
  return len;
}

int main() {
  /* Napisati za DZ... */
  return EXIT_SUCCESS;
}
